## API

### Supported Compositions

#### composeFa
```
Signature :: (f: (a: A) => F) => (a: A) => F
Composition :: f(a)
```

#### composeFab
```
Signature :: (f: (a: A) => (b: B) => F) => (a: A) => (b: B) => F
Composition :: f(a)(b)
```

#### composeFabc
```
Signature :: (f: (a: A) => (b: B) => (c: C) => F) => (a: A) => (b: B) => (c: C) => F
Composition :: f(a)(b)(c)
```

#### composeFba
```
Signature :: (f: (b: B) => (a: A) => F) => (a: A) => (b: B) => F
Composition :: f(b)(a)
```

#### composeFbac
```
Signature :: (f: (b: B) => (a: A) => (c: C) => F) => (a: A) => (b: B) => (c: C) => F
Composition :: f(b)(a)(c)
```

#### composeFbca
```
Signature :: (f: (b: B) => (c: C) => (a: A) => F) => (a: A) => (b: B) => (c: C) => F
Composition :: f(b)(c)(a)
```

#### composeFcab
```
Signature :: (f: (c: C) => (a: A) => (b: B) => F) => (a: A) => (b: B) => (c: C) => F
Composition :: f(c)(a)(b)
```

#### composeFcba
```
Signature :: (f: (c: C) => (b: B) => (a: A) => F) => (a: A) => (b: B) => (c: C) => F
Composition :: f(c)(b)(a)
```

#### composeFgabcGa
```
Signature :: (f: (g: G) => (a: A) => (b: B) => (c: C) => F) => (g: (a: A) => G) => (a: A) => (b: B) => (c: C) => F
Composition :: f(g(a))(a)(b)(c)
```

#### composeFgabcGab
```
Signature :: (f: (g: G) => (a: A) => (b: B) => (c: C) => F) => (g: (a: A) => (b: B) => G) => (a: A) => (b: B) => (c: C) => F
Composition :: f(g(a)(b))(a)(b)(c)
```

#### composeFgabcGabc
```
Signature :: (f: (g: G) => (a: A) => (b: B) => (c: C) => F) => (g: (a: A) => (b: B) => (c: C) => G) => (a: A) => (b: B) => (c: C) => F
Composition :: f(g(a)(b)(c))(a)(b)(c)
```

#### composeFgabcGb
```
Signature :: (f: (g: G) => (a: A) => (b: B) => (c: C) => F) => (g: (b: B) => G) => (a: A) => (b: B) => (c: C) => F
Composition :: f(g(b))(a)(b)(c)
```

#### composeFgabcGc
```
Signature :: (f: (g: G) => (a: A) => (b: B) => (c: C) => F) => (g: (c: C) => G) => (a: A) => (b: B) => (c: C) => F
Composition :: f(g(c))(a)(b)(c)
```

#### composeFgabGa
```
Signature :: (f: (g: G) => (a: A) => (b: B) => F) => (g: (a: A) => G) => (a: A) => (b: B) => F
Composition :: f(g(a))(a)(b)
```

#### composeFgabGab
```
Signature :: (f: (g: G) => (a: A) => (b: B) => F) => (g: (a: A) => (b: B) => G) => (a: A) => (b: B) => F
Composition :: f(g(a)(b))(a)(b)
```

#### composeFgabGabc
```
Signature :: (f: (g: G) => (a: A) => (b: B) => F) => (g: (a: A) => (b: B) => (c: C) => G) => (a: A) => (b: B) => (c: C) => F
Composition :: f(g(a)(b)(c))(a)(b)
```

#### composeFgaGa
```
Signature :: (f: (g: G) => (a: A) => F) => (g: (a: A) => G) => (a: A) => F
Composition :: f(g(a))(a)
```

#### composeFgaGab
```
Signature :: (f: (g: G) => (a: A) => F) => (g: (a: A) => (b: B) => G) => (a: A) => (b: B) => F
Composition :: f(g(a)(b))(a)
```

#### composeFgaGabc
```
Signature :: (f: (g: G) => (a: A) => F) => (g: (a: A) => (b: B) => (c: C) => G) => (a: A) => (b: B) => (c: C) => F
Composition :: f(g(a)(b)(c))(a)
```

#### composeFgaGb
```
Signature :: (f: (g: G) => (a: A) => F) => (g: (b: B) => G) => (a: A) => (b: B) => F
Composition :: f(g(b))(a)
```

#### composeFgbGa
```
Signature :: (f: (g: G) => (b: B) => F) => (g: (a: A) => G) => (a: A) => (b: B) => F
Composition :: f(g(a))(b)
```

#### composeFgGa
```
Signature :: (f: (g: G) => F) => (g: (a: A) => G) => (a: A) => F
Composition :: f(g(a))
```

#### composeFgGab
```
Signature :: (f: (g: G) => F) => (g: (a: A) => (b: B) => G) => (a: A) => (b: B) => F
Composition :: f(g(a)(b))
```

#### composeFgGabc
```
Signature :: (f: (g: G) => F) => (g: (a: A) => (b: B) => (c: C) => G) => (a: A) => (b: B) => (c: C) => F
Composition :: f(g(a)(b)(c))
```

#### composeFgGacb
```
Signature :: (f: (g: G) => F) => (g: (a: A) => (c: C) => (b: B) => G) => (a: A) => (b: B) => (c: C) => F
Composition :: f(g(a)(c)(b))
```

#### composeFgGbac
```
Signature :: (f: (g: G) => F) => (g: (b: B) => (a: A) => (c: C) => G) => (a: A) => (b: B) => (c: C) => F
Composition :: f(g(b)(a)(c))
```

#### composeFgGba
```
Signature :: (f: (g: G) => F) => (g: (b: B) => (a: A) => G) => (a: A) => (b: B) => F
Composition :: f(g(b)(a))
```
