import {composeFgGbac as compose} from "../composeFgGbac";
import {a, b, c, fn1 as F, fn3 as G} from "./utilities";

describe("Partial Application", () => {

    test("Unary", () => {
        expect(compose.length).toStrictEqual(1);
        expect(compose(F).length).toStrictEqual(1);
        expect(compose(F)(G).length).toStrictEqual(1);
        expect(compose(F)(G)(a).length).toStrictEqual(1);
        expect(compose(F)(G)(a)(b).length).toStrictEqual(1);
        expect(compose(F)(G)(a)(b)(c).length).toStrictEqual(1);
    });

});

describe("Referential Transparency", () => {

    test("Extensional Equality", () => {
        expect(compose(F)(G)(a)(b)(c)).toStrictEqual([[b, a, c]]);
        expect(compose(F)(G)(a)(c)(b)).toStrictEqual([[c, a, b]]);
        expect(compose(F)(G)(b)(a)(c)).toStrictEqual([[a, b, c]]);
        expect(compose(F)(G)(b)(c)(a)).toStrictEqual([[c, b, a]]);
        expect(compose(F)(G)(c)(a)(b)).toStrictEqual([[a, c, b]]);
        expect(compose(F)(G)(c)(b)(a)).toStrictEqual([[b, c, a]]);
    });

});
